-- #######################################
-- #                 PATH                #
-- #                                     #
-- # Code du menu                        #
-- #######################################

path_menu_displayed = false
path_menu_currentSelection = 1
path_menu_folder = 0
path_menu_folder_stack = {}

path_menu_scroll = 0

path_menu_items = {}
	
path_menu_currentItems = {}

path_menu_title_forecolor = "#ffffff"
path_menu_title_backcolor = "#000000"
path_menu_forecolor = "#00ffff"
path_menu_backcolor = "#0000ff"
path_menu_text_backcolor = "#00000000"
path_menu_cursor_forecolor = "#ffffff"
path_menu_cursor_backcolor = "#00000000"
path_menu_cursor = "->"

path_menu_displayed = false

function path_menu()
	if path_pad_pressed("L") then
		if path_menu_displayed == true then path_menu_save() end
		path_menu_displayed = not path_menu_displayed
	end
	
	if not path_menu_displayed then return end
	
	if path_pad_pressed("down") then path_menu_down() end
	if path_pad_pressed("up") then path_menu_up() end
	if path_pad_pressed("A") then path_menu_select() end
	if path_pad_pressed("B") and #path_menu_folder_stack > 0 then path_menu_back() end
	
	if path_menu_currentSelection < 1 and path_menu_scroll > 0 then
		path_menu_currentSeection = 1
		path_menu_scroll = path_menu_scroll - 1
	end
	if path_menu_currentSelection + path_menu_scroll > #path_menu_currentItems then
		path_menu_currentSelection = path_menu_currentSelection - 1
	end
	if path_menu_currentSelection > 20 then
		path_menu_currentSelection = path_menu_currentSelection - 1
		path_menu_scroll = path_menu_scroll + 1
	end
	
	gui.drawrect(0, 0, 255, 191, path_menu_backcolor)
	gui.drawrect(0, 0, 255, 10, path_menu_title_backcolor)
	
	if #path_menu_folder_stack == 0 then
		gui.boldtext(2, 2, path_message_menu_mainMenu, path_menu_title_forecolor, path_menu_title_backcolor)
	elseif #path_menu_folder_stack >= 1 then
		gui.boldtext(2, 2, path_menu_items[path_menu_folder][1], path_menu_title_forecolor, path_menu_title_backcolor)
	end
	
	for i = path_menu_scroll + 1, path_menu_scroll + 20 do
		if #path_menu_currentItems >= i then
			gui.text(18, 8 + 8 * (i - path_menu_scroll), path_menu_currentItems[i][1][1], path_menu_forecolor, path_menu_text_backcolor)
		end
	end
	
	if #path_menu_folder_stack > 1 then
		gui.text(0, 183, "< "..path_menu_items[path_menu_folder_stack[#path_menu_folder_stack][1]][1], path_menu_forecolor, path_menu_text_backcolor)
	elseif #path_menu_folder_stack == 1 then
		gui.text(0, 183, "< "..path_message_menu_mainMenu, path_menu_forecolor, path_menu_text_backcolor)
	end
	
	if #path_menu_currentItems > 0 then
		gui.boldtext(0, 8 + (8 * (path_menu_currentSelection)), path_menu_cursor, path_menu_cursor_forecolor, path_menu_cursor_backcolor)
	else
		gui.text(0, 16, path_message_menu_nothing, path_menu_forecolor, path_menu_text_backcolor)
	end
	
	path_pad_out.up = false
	path_pad_out.down = false
	path_pad_out.left = false
	path_pad_out.right = false
	path_pad_out.A = false
	path_pad_out.B = false
	path_pad_out.X = false
	path_pad_out.Y = false
	path_pad_out.L = false
	path_pad_out.R = false
	
	path_pad_set()
	
end

function path_menu_addItem(name, folder, value)
	table.insert(path_menu_items, {name, folder, value})
	path_menu_updateItems()
	return #path_menu_items
end

function path_menu_removeItem(id)
	table.remove(path_menu_items, id)
end

function path_menu_replaceItem(id, name, value)
	path_menu_items[id][1] = name
	path_menu_items[id][3] = value
end

function path_menu_getItem(id)
	return path_menu_items[id]
end

function path_menu_down()
	if path_menu_currentSelection + path_menu_scroll < #path_menu_currentItems then
		path_menu_currentSelection = path_menu_currentSelection + 1
	end
end

function path_menu_up()
	if path_menu_currentSelection + path_menu_scroll > 1 then
		path_menu_currentSelection = path_menu_currentSelection - 1
	end
end

function path_menu_getSelectedItem()
	return path_menu_currentItems[path_menu_currentSelection + path_menu_scroll]
end

function path_menu_select()
	if path_menu_currentSelection > 0 then
		if type(path_menu_getSelectedItem()[1][3]) == "function" then
			path_menu_getSelectedItem()[1][3]()
		elseif type(path_menu_getSelectedItem()[1][3]) == "nil" then
			table.insert(path_menu_folder_stack, {path_menu_folder, path_menu_scroll, path_menu_currentSelection})
			path_menu_folder = path_menu_getSelectedItem()[2]
			path_menu_updateItems()
		end
	end
end

function path_menu_back()
	if #path_menu_folder_stack > 0 then
		path_menu_folder = path_menu_folder_stack[#path_menu_folder_stack][1]
		scroll = path_menu_folder_stack[#path_menu_folder_stack][2]
		currentSelection = path_menu_folder_stack[#path_menu_folder_stack][3]
		table.remove(path_menu_folder_stack)
		path_menu_updateItems()
	end
	
	path_menu_scroll = scroll
	path_menu_currentSelection = currentSelection
end

function path_menu_updateItems()
	path_menu_currentItems = {}
	for i in pairs(path_menu_items) do
		if path_menu_items[i][2] == path_menu_folder then
			table.insert(path_menu_currentItems, {path_menu_items[i], i})
		end
	end
	
	path_menu_scroll = 0
	path_menu_currentSelection = 1
end

function path_menu_save()
	menufile = io.open("options.dat", "w")
	if menufile == nil then path_debug(path_message_menu_errOptionsWr); return end
	menufile:write("path_loadline_enabled="..tostring(path_loadline_enabled))
	menufile:write("\npath_loadline_perspective="..path_loadline_perspective)
	menufile:write("\npath_gui_showJoypad="..tostring(path_gui_showJoypad))
	menufile:write("\npath_gui_showData="..tostring(path_gui_showData))
	menufile:write("\npath_map_showMapLocation="..tostring(path_map_showMapLocation))
	menufile:write("\npath_language=\""..path_language.."\"")
	menufile:close()
	path_debug(path_message_menu_saved)
end

function path_menu_load()
	if(path_language == nil) then path_language="en" end
	
	langfile = io.open("lang_"..path_language..".lua")
	if langfile == nil then
		path_debug("PATH is missing a language file.")
		path_debug("Please place lang_"..path_language..".lua next to inc_menu.lua.")
		while true do -- freezing loop
			emu.frameadvance()
		end
	else
		dofile("lang_"..path_language..".lua")
	end
	langfile:close()
	
	menufile = io.open("options.dat", "r")
	if menufile == nil then path_debug(path_message_menu_errOptionsRe); return end
	menufile:close()
	dofile("options.dat")
	dofile("lang_"..path_language..".lua")
	
	path_debug(path_message_menu_loaded)
end

path_menu_load()
path_menu_updateItems()
