-- #######################################
-- #                 PATH                #
-- #                                     #
-- # Code de gestion des modules         #
-- #######################################

path_module_name = {}
path_module_func = {}
path_module_enabled = {}

function path_module_exec()
	i = nil
	for i in pairs(path_module_name) do
		if path_module_enabled[i] then path_module_func[i]() end
	end
end

function path_module_getModuleID(moduleName)
	if #path_module_name > 0 then
		for i in pairs(path_module_name) do
			if path_module_name[i] == moduleName then
				return i
			end
		end
	end
	return 0
end

function path_module_register(moduleName, functionName)
	table.insert(path_module_name, moduleName)
	table.insert(path_module_func, functionName)
	table.insert(path_module_enabled, true)
	path_debug(path_message_module_loaded..moduleName)
end

function path_module_changeState(moduleName, state)
	i = path_module_getModuleID(moduleName)
	if i > 0 then
		path_module_enabled[i] = state
		if state then
			path_debug(path_message_module_enabled..moduleName)
		else
			path_debug(path_message_module_disabled..moduleName)
		end
		return false
	else
		return true
	end
end

function path_module_getModuleList()
	return path_module_name
end
