-- #######################################
-- #                 PATH                #
-- #                                     #
-- # Fichier de dclaration des          #
-- # variables                           #
-- #######################################

-- # POINTEURS # --
path_ptr_main = 0
path_ptr_centerPiece = 0
path_ptr_location = 0
path_ptr_matrixID = 0
path_ptr_xPos = 0
path_ptr_yPos = 0

-- # VARIABLES TECHNIQUES # --
path_centerPiece = 0
path_location = 0
path_matrixID = 0
path_xPos = 0
path_yPos = 0

-- # DIRECTIONS # --
E = 0	-- Est = 0 rad
N = 1	-- Nord = (pi / 2) rad
O = 2	-- Ouest = pi rad
S = 3	-- Sud = (3pi / 2) rad

-- # CHEMINS PREDEFINIS # --
path_path_north_fs = {446, E, 64500, N}
path_path_north_fs_alternative = {875, E, 64500, N}
path_path_giratina_1st = {10, O, 300, S}
path_path_giratina_2nd = {116, S}

-- # VARIABLES DU SCRIPT # --
path_version = "PATH 1.2.2"
path_game_version = ""

function path_checkptr()
	if memory.readdword(0x23ffe0c) == 0x46414441 or memory.readdword(0x23ffe0c) == 0x46415041 then	-- Compatibilit avec Pokmon D/P (F)
		path_ptr_main = memory.readdword(0x021C4EA8)
		path_ptr_xPos = path_ptr_main + 0x31D58
		path_ptr_yPos = path_ptr_main + 0x31D60
		path_ptr_matrixID = path_ptr_main + 0x2FD96
		path_ptr_centerPiece = path_ptr_main + 0x2FD9A
		path_ptr_location = path_ptr_main + 0xE70C
		path_game_version = "DPP"
	elseif memory.readdword(0x23ffe0c) == 0x45414441 or memory.readdword(0x23ffe0c) == 0x45415041 then -- Compatibilit avec Pokmon D/P (EU/US)
		path_ptr_main = memory.readdword(0x02106fc0)
		path_ptr_xPos = path_ptr_main + 0x24A98
		path_ptr_yPos = path_ptr_main + 0x24AA0
		path_ptr_matrixID = path_ptr_main + 0x22AD6
		path_ptr_centerPiece = path_ptr_main + 0x22ADA
		path_ptr_location = path_ptr_main + 0x144C
		path_game_version = "DPP"
	elseif memory.readdword(0x23ffe0c) == 0x4A414441 then -- Compatibilit avec Pokmon D (JP)
		path_ptr_main = memory.readdword(0x2108818)
		path_ptr_xPos = path_ptr_main + 0x24A98
		path_ptr_yPos = path_ptr_main + 0x24AA0
		path_ptr_matrixID = path_ptr_main + 0x22AD6
		path_ptr_centerPiece = path_ptr_main + 0x22ADA
		path_ptr_location = path_ptr_main + 0x144C
		path_game_version = "DPP"
	elseif memory.readdword(0x23ffe0c) == 0x4A415041 then -- Compatibilit avec Pokmon P (JP)
		path_ptr_main = memory.readdword(0x2108958)
		path_ptr_xPos = path_ptr_main + 0x24A98
		path_ptr_yPos = path_ptr_main + 0x24AA0
		path_ptr_matrixID = path_ptr_main + 0x22AD6
		path_ptr_centerPiece = path_ptr_main + 0x22ADA
		path_ptr_location = path_ptr_main + 0x144C
		path_game_version = "DPP"
	elseif memory.readdword(0x23ffe0c) == 0x464B5049 or memory.readdword(0x23ffe0c) == 0x46475049 then -- Compatibilit avec Pokmon HG/SS (F)
		path_ptr_main = memory.readdword(0x021118A0)
		path_ptr_centerPiece = path_ptr_main + 0x24166
		path_ptr_location = path_ptr_main + 0x1244
		path_ptr_matrixID = path_ptr_main + 0x24162
		path_ptr_xPos = path_ptr_main + 0x25DE4
		path_ptr_yPos = path_ptr_main + 0x25DEC
		path_game_version = "HGSS"
	elseif memory.readdword(0x23ffe0c) == 0x454B5049 or memory.readdword(0x23ffe0c) == 0x45475049 then -- Compatibilit avec Pokmon HG/SS (US/EU)
		path_ptr_main = memory.readdword(0x02111880)
		path_ptr_centerPiece = path_ptr_main + 0x24166
		path_ptr_location = path_ptr_main + 0x1244
		path_ptr_matrixID = path_ptr_main + 0x24162
		path_ptr_xPos = path_ptr_main + 0x25DE4
		path_ptr_yPos = path_ptr_main + 0x25DEC
		path_game_version = "HGSS"
	elseif memory.readdword(0x23ffe0c) == 0x4A4B5049 or memory.readdword(0x23ffe0c) == 0x4A475049 then -- Compatibilit avec Pokmon HG/SS (JP)
		path_ptr_main = memory.readdword(0x02110dc0)
		path_ptr_centerPiece = path_ptr_main + 0x24166
		path_ptr_location = path_ptr_main + 0x1244
		path_ptr_matrixID = path_ptr_main + 0x24162
		path_ptr_xPos = path_ptr_main + 0x25DE4
		path_ptr_yPos = path_ptr_main + 0x25DEC
		path_game_version = "HGSS"
	elseif memory.readdword(0x23ffe0c) == 0x46555043 then -- Compatibilit avec Pokmon Pl (FR)
		path_ptr_main = memory.readdword(0x02101F20)
		path_ptr_centerPiece = path_ptr_main + 0x218FE
		path_ptr_location = path_ptr_main + 0x1294
		path_ptr_matrixID = path_ptr_main + 0x218FA
		path_ptr_xPos = path_ptr_main + 0x238E0
		path_ptr_yPos = path_ptr_main + 0x238E8
		path_game_version = "DPP"
	elseif memory.readdword(0x23ffe0c) == 0x45555043 then -- Compatibilit avec Pokmon Pl (EU/US)
		path_ptr_main = memory.readdword(0x02101D40)
		path_ptr_centerPiece = path_ptr_main + 0x218FE
		path_ptr_location = path_ptr_main + 0x1294
		path_ptr_matrixID = path_ptr_main + 0x218FA
		path_ptr_xPos = path_ptr_main + 0x238E0
		path_ptr_yPos = path_ptr_main + 0x238E8
		path_game_version = "DPP"
	elseif memory.readdword(0x23ffe0c) == 0x4a555043 then -- Compatibilit avec Pokmon Pl (J)
		path_ptr_main = memory.readdword(0x02101140)
		path_ptr_centerPiece = path_ptr_main + 0x218FE
		path_ptr_location = path_ptr_main + 0x1294
		path_ptr_matrixID = path_ptr_main + 0x218FA
		path_ptr_xPos = path_ptr_main + 0x238E0
		path_ptr_yPos = path_ptr_main + 0x238E8
		path_game_version = "DPP"
	end
end

function path_vars() -- fonction d'actualisation des variables
	path_checkptr()
	
	path_centerPiece = memory.readword(path_ptr_centerPiece)
	path_location = memory.readword(path_ptr_location)
	path_matrixID = memory.readword(path_ptr_matrixID)
	path_xPos = memory.readdword(path_ptr_xPos)
	path_yPos = memory.readdword(path_ptr_yPos)
end

path_vars()
