-- #######################################
-- #                 PATH                #
-- #                                     #
-- # Module d'affichage des donnes de   #
-- # dbogage sur l'cran                #
-- #######################################

path_gui_forecolor = ("#ffffffff")
path_gui_backcolor = ("#00000080")
path_gui_disabledcolor = ("#ff0000ff")
path_gui_enabledcolor = ("#ffffffff")

path_gui_showJoypad = true
path_gui_showData = true

function path_gui()
	gui.text(0, -191, path_version, path_gui_forecolor, path_gui_backcolor)
	
	if path_gui_showData then
		gui.text(0, -175, "CENTP = "..path_centerPiece, path_gui_forecolor, path_gui_backcolor)
		gui.text(0, -167, "LOCID = "..path_location, path_gui_forecolor, path_gui_backcolor)
		gui.text(0, -159, "MATRX = "..path_matrixID, path_gui_forecolor, path_gui_backcolor)
		gui.text(0, -151, "POS X = "..path_xPos % 65536, path_gui_forecolor, path_gui_backcolor)
		gui.text(0, -143, "POS Y = "..path_yPos % 65536, path_gui_forecolor, path_gui_backcolor)
		
		if path_run_enabled then
			gui.text(0, -135, "RMNG  = "..path_run_step_goal - path_run_step_doneSteps, path_gui_forecolor, path_gui_backcolor)
			gui.drawrect(0, -11, 255, -1, "#7f7f7f")
			gui.drawrect(0, -11, path_run_step_doneSteps * 255 / path_run_step_goal, -1, "#ff0000")
			gui.centertext(-9, math.floor(path_run_step_doneSteps * 100 / path_run_step_goal).."%", path_gui_forecolor, path_gui_backcolor)
		end
		
		if path_xPos > 65535 or path_yPos > 65535 then
			gui.text(0, -119, "FS X="..math.floor(path_xPos / 65536).." Y="..math.floor(path_yPos / 65536), path_gui_forecolor, path_gui_backcolor)
		end
	end
	
	if path_gui_showJoypad then
		if path_pad_in.left then gui.text(0, 175, "<", path_gui_enabledcolor, path_gui_backcolor) else gui.text(0, 175, "<", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.down then gui.text(6, 183, "v", path_gui_enabledcolor, path_gui_backcolor) else gui.text(6, 183, "v", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.right then gui.text(12, 175, ">", path_gui_enabledcolor, path_gui_backcolor) else gui.text(12, 175, ">", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.up then gui.text(6, 167, "^", path_gui_enabledcolor, path_gui_backcolor) else gui.text(6, 167, "^", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.select then gui.text(18, 175, "se", path_gui_enabledcolor, path_gui_backcolor) else gui.text(18, 175, "se", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.start then gui.text(30, 175, "st", path_gui_enabledcolor, path_gui_backcolor) else gui.text(30, 175, "st", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.X then gui.text(48, 167, "X", path_gui_enabledcolor, path_gui_backcolor) else gui.text(48, 167, "X", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.Y then gui.text(42, 175, "Y", path_gui_enabledcolor, path_gui_backcolor) else gui.text(42, 175, "Y", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.A then gui.text(54, 175, "A", path_gui_enabledcolor, path_gui_backcolor) else gui.text(54, 175, "A", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.B then gui.text(48, 183, "B", path_gui_enabledcolor, path_gui_backcolor) else gui.text(48, 183, "B", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.L then gui.text(18, 159, "L", path_gui_enabledcolor, path_gui_backcolor) else gui.text(18, 159, "L", path_gui_disabledcolor, path_gui_backcolor) end
		if path_pad_in.R then gui.text(36, 159, "R", path_gui_enabledcolor, path_gui_backcolor) else gui.text(36, 159, "R", path_gui_disabledcolor, path_gui_backcolor) end
	end
end

function gui.drawRectangle(x1, y1, x2, y2, color)
	gui.drawline(x1, y1, x2, y1, color)
	gui.drawline(x2, y1, x2, y2, color)
	gui.drawline(x2, y2, x1, y2, color)
	gui.drawline(x1, y2, x1, y1, color)
end

function gui.boldtext(x, y, text, fc, bc)
	gui.text(x, y, text, fc, bc)
	gui.text(x + 1, y, text, fc, bc)
	gui.text(x, y, text, fc, "#00000000")
end

function gui.centertext(y, text, fc, bc)
	gui.text(127 - (string.len(text) / 2), y, text, fc, bc)
end

function path_gui_showj()
path_gui_showJoypad = true
end

function path_gui_hidej()
path_gui_showJoypad = false
end

function path_gui_showInfo()
path_gui_showData = true
end

function path_gui_hideInfo()
path_gui_showData = false
end

fld = path_menu_addItem(path_message_gui_mainMenu, 0, nil)
fld2 = path_menu_addItem(path_message_gui_subMenu1, fld, nil)
path_menu_addItem(path_message_gui_showJoypad, fld2, path_gui_showj)
path_menu_addItem(path_message_gui_hideJoypad, fld2, path_gui_hidej)
fld2 = path_menu_addItem(path_message_gui_subMenu2, fld, nil)
path_menu_addItem(path_message_gui_showInfo, fld2, path_gui_showInfo)
path_menu_addItem(path_message_gui_hideInfo, fld2, path_gui_hideInfo)
