-- #######################################
-- #                PATH                 #
-- #                                     #
-- # Module de dplacement autonome      #
-- #######################################

-- Script   autonome   permettant   de  se
-- dplacer  dans la void  sans rester  en
-- permanence devant  son PC  appuyer sur
-- le bouton.
-- Il est recommand de lancer le script 
-- partir du point de dpart  430N.

-- # PROGRAMMATION DU CHEMIN # --
-- Dans cette srie de nombres, vous devez
-- rentrer  votre chemin  selon le  schma
-- suivant  :  {nombre_de_pas, direction},
-- o nombre_de_pas est le nombre de pas 
-- effectuer  par tape, et direction  une
-- valeur parmi E, N, O, S (Est, Nord, ..)

path_path_original = {446, E, 64500, N}

path_run_enabled = false

path_run_step_number = 0
path_run_step_goal = 0
path_run_step_direction = 0
path_run_step_doneSteps = 0
path_run_step_slowCount = 0
path_run_oldX = 0
path_run_oldY = 0

path_run_wall_oldX = 0
path_run_wall_oldY = 0
path_run_wall_timer = 0
path_run_wall_direction = 0
path_run_wall_detected = false
path_run_wall_doneSteps = 0
path_run_wall_oldDoneSteps = 0
path_run_wall_oldDirSteps = 0
path_run_wall_errtable = {}
path_run_wall_directionTable = {"E", "N", "O", "S"}
path_run_wall_directionChanges = 0

function path_run()	
	if path_run_enabled then
		if not path_menu_displayed then
			if not path_run_wall_detected then
				if path_run_oldX ~= path_xPos or path_run_oldY ~= path_yPos then
					path_run_oldX = path_xPos
					path_run_oldY = path_yPos
					path_run_step_doneSteps = path_run_step_doneSteps + 1
					path_run_wall_timer = 0
				end
			
				-- vnement : fin de l'tape
				if path_run_step_doneSteps == path_run_step_goal then
					path_debug(path_message_run_stepEnd)
					path_run_step_number = path_run_step_number + 1
					-- vnement : fin du trajet
					if path_run_step_number * 2 == #path_path then
						path_run_enabled = false
						path_debug(path_message_run_end)
					else
						path_run_loadStep(path_run_step_number)
					end
				else
					-- vnement : <= 5 pas  faire pour arriver au but
					if path_run_step_goal - path_run_step_doneSteps <= 5 then
						path_run_step_slowCount = path_run_step_slowCount + 1
						if path_run_step_slowCount == 7 then
							path_run_setOutput(path_run_step_direction)
							path_run_step_slowCount = 0
						end
					else
						path_run_setOutput(path_run_step_direction)
					end
				end
				
				if path_run_oldX == path_xPos and path_run_oldY == path_yPos then
					path_run_wall_timer = path_run_wall_timer + 1
				end
				
				if path_run_wall_timer > 60 then
					path_run_wall_detected = true
					path_run_wall_doneSteps = 0
					path_run_wall_direction = (path_run_step_direction + 1) % 4
					path_run_wall_timer = 0
					path_run_wall_oldDoneSteps = 0
					path_run_wall_directionChanges = 0
					path_debug(path_message_run_wall1..path_run_step_doneSteps..path_message_run_wall2)
				end
				
			else -- contournement du mur
				if path_run_wall_timer > 50 and path_run_wall_timer < 60 then
					path_run_setOutput(path_run_wall_direction)
				end
				if path_run_wall_timer > 110 and path_run_wall_timer < 120 then
					path_run_setOutput(path_run_step_direction)
				end
				if path_run_wall_timer >= 120 then
					path_run_wall_timer = 0
					if path_run_wall_doneSteps - path_run_wall_oldDoneSteps == 0 then
						if path_run_wall_directionChanges == 0 then
							path_run_wall_directionChanges = 1
							path_run_wall_direction = (path_run_wall_direction + 2) % 4
							path_run_wall_oldDirSteps = path_run_wall_doneSteps
							path_run_wall_doneSteps = 0
							path_run_wall_oldDoneSteps = 0
						else
							path_run_enabled = false
							path_run_reset()
						end
					else
						path_run_wall_oldDoneSteps = path_run_wall_doneSteps
					end
				end
				
				if ((path_run_step_direction == N or path_run_step_direction == S) and (path_run_oldY ~= path_yPos)) or ((path_run_step_direction == O or path_run_step_direction == E) and (path_run_oldX ~= path_xPos)) then
					if path_run_wall_doneSteps - path_run_wall_oldDirSteps > 0 then
						table.insert(path_path, path_run_wall_doneSteps - path_run_wall_oldDirSteps)
						table.insert(path_path, (path_run_wall_direction + 2) % 4)
						path_run_wall_timer = 0
						path_run_wall_detected = false
						path_run_step_doneSteps = path_run_step_doneSteps + 1
						path_debug(path_message_run_bypassDone..path_run_wall_doneSteps - path_run_wall_oldDirSteps..path_run_wall_directionTable[path_run_wall_direction + 1])
					else
						path_debug(path_message_run_bypassFailed)
					end
				end
				
				if path_run_oldX ~= path_xPos or path_run_oldY ~= path_yPos then
					path_run_wall_doneSteps = path_run_wall_doneSteps + 1
					path_run_oldX = path_xPos
					path_run_oldY = path_yPos
				end
				
				path_run_wall_timer = path_run_wall_timer + 1
			end
		else
			if path_run_oldX ~= path_xPos or path_run_oldY ~= path_yPos then
				path_run_oldX = path_xPos
				path_run_oldY = path_yPos
				path_run_step_doneSteps = path_run_step_doneSteps + 1
				path_run_wall_timer = 0
			end
		end
	end
end

function path_run_loadStep(number)
	path_run_step_number = number
	path_run_step_goal = path_path[number * 2 + 1]
	path_run_step_direction = path_path[number * 2 + 2]
	path_run_step_doneSteps = 0
	path_run_oldX = path_xPos
	path_run_oldY = path_yPos
	path_debug(path_message_run_steploaded1..path_run_step_number..path_message_run_steploaded2..path_run_step_goal..path_message_run_steploaded3..path_run_wall_directionTable[path_run_step_direction + 1])
end

function path_run_reset()
	path_run_step_number = 0
	path_run_step_goal = 0
	path_run_step_direction = 0
	path_run_step_doneSteps = 0
	path_run_oldX = 0
	path_run_oldY = 0
	path_run_wall_detected = false
	path_run_wall_timer = 0
	path_debug(path_message_run_reset)
end

function path_run_setOutput(direction)
	if direction == E then path_pad_out.right = true end
	if direction == N then path_pad_out.up = true end
	if direction == O then path_pad_out.left = true end
	if direction == S then path_pad_out.down = true end
	path_pad_set()
end

function path_run_menu_enable()
	if path_run_enabled == false then
		path_run_reset()
		path_run_enabled = true
		path_path = path_path_original
		path_run_loadStep(path_run_step_number)
		path_debug(path_message_run_enabled)
	end
end

function path_run_menu_disable()
	if path_run_enabled == true then
		path_run_enabled = false
		path_debug(path_message_run_disabled)
	end
end

function path_run_menu_reset()
	path_run_reset()
	path_run_enabled = false
end

path_module_register("RUN", path_run)
fld = path_menu_addItem(path_message_run_mainMenu, 0, nil)
path_menu_addItem(path_message_run_start, fld, path_run_menu_enable)
path_menu_addItem(path_message_run_stop, fld, path_run_menu_disable)
path_menu_addItem(path_message_run_menuReset, fld, path_run_menu_reset)
