-- #######################################
-- #                 PATH                #
-- #                                     #
-- # Code du module de tweak auto        #
-- #######################################

path_tweak_enabled = false
path_tweak_waiting = false
path_tweak_personnalPattern = {1, 0, 3, 2, 1, 0, 3, 2, 1, 0, 3, 1, 2}
path_tweak_pattern = {} -- 0 = est, 1 = nord, 2 = ouest, 3 = sud
path_tweak_currentStep = 0
path_tweak_oldX = 0
path_tweak_oldY = 0

function path_tweak()
	if (not path_menu_displayed) and (path_tweak_waiting) then
		path_tweak_enabled = true
		path_tweak_waiting = false
		path_tweak_currentStep = 1
		path_tweak_oldX = path_xPos
		path_tweak_oldY = path_yPos
		path_debug(path_message_tweak_enabled)
	end
	
	if path_tweak_enabled then
		if path_menu_displayed then
			path_tweak_disable()
		end
		
		if (path_tweak_oldX ~= path_xPos) or (path_tweak_oldY ~= path_yPos) then
			path_tweak_currentStep = path_tweak_currentStep + 1
			path_tweak_oldX = path_xPos
			path_tweak_oldY = path_yPos
		end
		if path_tweak_currentStep > #path_tweak_pattern then
			path_debug(path_message_tweak_end)
			path_tweak_disable()
		end
		
		if path_tweak_pattern[path_tweak_currentStep] == 0 then path_pad_out.right = true end
		if path_tweak_pattern[path_tweak_currentStep] == 1 then path_pad_out.up = true end
		if path_tweak_pattern[path_tweak_currentStep] == 2 then path_pad_out.left = true end
		if path_tweak_pattern[path_tweak_currentStep] == 3 then path_pad_out.down = true end
		
		path_pad_set()
	end
end

function path_tweak_disable()
	path_tweak_enabled = false
	path_tweak_currentStep = 0
	path_tweak_oldX = 0
	path_tweak_oldY = 0
	path_debug(path_message_tweak_disabled)
end

path_module_register("TWEAK", path_tweak)
fld = path_menu_addItem(path_message_tweak_mainMenu, 0, nil)

if(path_game_version == "DPP") then
	function path_tweak_ul_ur() path_tweak_pattern = {0, 1, 2, 3, 1, 0}; path_tweak_waiting = true end
	function path_tweak_ur_ul() path_tweak_pattern = {1, 0, 3, 1, 2}; path_tweak_waiting = true end
	function path_tweak_ul_dl() path_tweak_pattern = {1, 0, 2, 3}; path_tweak_waiting = true end
	function path_tweak_dl_ul() path_tweak_pattern = {1, 3, 0, 2, 1}; path_tweak_waiting = true end
	function path_tweak_ur_dr() path_tweak_pattern = {0, 1, 2, 0, 3}; path_tweak_waiting = true end
	function path_tweak_dr_ur() path_tweak_pattern = {1, 0, 3, 2, 0, 1}; path_tweak_waiting = true end
	function path_tweak_dl_dr() path_tweak_pattern = {0, 2, 1, 3, 0}; path_tweak_waiting = true end
	function path_tweak_dr_dl() path_tweak_pattern = {0, 1, 3, 2}; path_tweak_waiting = true end
	function path_tweak_l_r() path_tweak_pattern = {0, 1, 2, 3, 0, 2, 0}; path_tweak_waiting = true end
	function path_tweak_r_l() path_tweak_pattern = {1, 0, 3, 2, 0, 2}; path_tweak_waiting = true end
	function path_tweak_u_d() path_tweak_pattern = {0, 1, 2, 3, 1, 3}; path_tweak_waiting = true end
	function path_tweak_d_u() path_tweak_pattern = {1, 0, 3, 2, 1, 3, 1}; path_tweak_waiting = true end
	path_menu_addItem(path_message_tweak_ul_ur, fld, path_tweak_ul_ur)
	path_menu_addItem(path_message_tweak_ur_ul, fld, path_tweak_ur_ul)
	path_menu_addItem(path_message_tweak_ul_dl, fld, path_tweak_ul_dl)
	path_menu_addItem(path_message_tweak_dl_ul, fld, path_tweak_dl_ul)
	path_menu_addItem(path_message_tweak_ur_dr, fld, path_tweak_ur_dr)
	path_menu_addItem(path_message_tweak_dr_ur, fld, path_tweak_dr_ur)
	path_menu_addItem(path_message_tweak_dl_dr, fld, path_tweak_dl_dr)
	path_menu_addItem(path_message_tweak_dr_dl, fld, path_tweak_dr_dl)
	path_menu_addItem(path_message_tweak_l_r, fld, path_tweak_l_r)
	path_menu_addItem(path_message_tweak_r_l, fld, path_tweak_r_l)
	path_menu_addItem(path_message_tweak_u_d, fld, path_tweak_u_d)
	path_menu_addItem(path_message_tweak_d_u, fld, path_tweak_d_u)
elseif(path_game_version == "HGSS") then
	function path_tweak_hg_u_d() path_tweak_pattern = {1, 0, 3, 2, 1, 3, 0}; path_tweak_waiting = true end
	function path_tweak_hg_d_u() path_tweak_pattern = {0, 1, 2, 3, 0, 1, 2, 3, 1, 0}; path_tweak_waiting = true end
	function path_tweak_hg_l_r() path_tweak_pattern = {0, 1, 2, 3, 0, 1, 2, 0, 3}; path_tweak_waiting = true end
	function path_tweak_hg_r_l() path_tweak_pattern = {1, 0, 3, 2, 1, 0, 2, 3}; path_tweak_waiting = true end
	function path_tweak_hg_i_u_d() path_tweak_pattern = {1, 0, 3, 2, 1, 0, 3, 1, 3}; path_tweak_waiting = true end
	function path_tweak_hg_i_d_u() path_tweak_pattern = {0, 1, 2, 3, 0, 1, 3, 1}; path_tweak_waiting = true end
	function path_tweak_hg_i_l_r() path_tweak_pattern = {0, 1, 2, 3, 0, 2, 0}; path_tweak_waiting = true end
	function path_tweak_hg_i_r_l() path_tweak_pattern = {1, 0, 3, 2, 0, 2}; path_tweak_waiting = true end
	path_menu_addItem(path_message_tweak_hg_u_d, fld, path_tweak_hg_u_d)
	path_menu_addItem(path_message_tweak_hg_d_u, fld, path_tweak_hg_d_u)
	path_menu_addItem(path_message_tweak_hg_l_r, fld, path_tweak_hg_l_r)
	path_menu_addItem(path_message_tweak_hg_r_l, fld, path_tweak_hg_r_l)
	path_menu_addItem(path_message_tweak_hg_i_u_d, fld, path_tweak_hg_i_u_d)
	path_menu_addItem(path_message_tweak_hg_i_d_u, fld, path_tweak_hg_i_d_u)
	path_menu_addItem(path_message_tweak_hg_i_l_r, fld, path_tweak_hg_i_l_r)
	path_menu_addItem(path_message_tweak_hg_i_r_l, fld, path_tweak_hg_i_r_l)
end
